#ifndef _STD_LCD_IO_H_
#define _STD_LCD_IO_H_

#include "stm32.h"
#include <nuttx/lcd/ili9327.h>

#define LCD_GPIO_RESET (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                        GPIO_OUTPUT_SET | GPIO_PORTD | GPIO_PIN12)

#define LCD_GPIO_CS (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                     GPIO_OUTPUT_SET | GPIO_PORTD | GPIO_PIN7)

#define LCD_GPIO_RS (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                     GPIO_OUTPUT_SET | GPIO_PORTD | GPIO_PIN11)

#define LCD_GPIO_WR (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                     GPIO_OUTPUT_SET | GPIO_PORTD | GPIO_PIN5)

#define LCD_GPIO_RD (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                     GPIO_OUTPUT_SET | GPIO_PORTD | GPIO_PIN4)

#define LCD_GPIO_OUTPUT_D0 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                            GPIO_OUTPUT_SET | GPIO_PORTD | GPIO_PIN14)

#define LCD_GPIO_OUTPUT_D1 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                            GPIO_OUTPUT_SET | GPIO_PORTD | GPIO_PIN15)

#define LCD_GPIO_OUTPUT_D2 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                            GPIO_OUTPUT_SET | GPIO_PORTD | GPIO_PIN0)

#define LCD_GPIO_OUTPUT_D3 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                            GPIO_OUTPUT_SET | GPIO_PORTD | GPIO_PIN1)

#define LCD_GPIO_OUTPUT_D4 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                            GPIO_OUTPUT_SET | GPIO_PORTE | GPIO_PIN7)

#define LCD_GPIO_OUTPUT_D5 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                            GPIO_OUTPUT_SET | GPIO_PORTE | GPIO_PIN8)

#define LCD_GPIO_OUTPUT_D6 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                            GPIO_OUTPUT_SET | GPIO_PORTE | GPIO_PIN9)

#define LCD_GPIO_OUTPUT_D7 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                            GPIO_OUTPUT_SET | GPIO_PORTE | GPIO_PIN10)

#define LCD_GPIO_OUTPUT_D8 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                            GPIO_OUTPUT_SET | GPIO_PORTE | GPIO_PIN11)

#define LCD_GPIO_OUTPUT_D9 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                            GPIO_OUTPUT_SET | GPIO_PORTE | GPIO_PIN12)

#define LCD_GPIO_OUTPUT_D10 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                             GPIO_OUTPUT_SET | GPIO_PORTE | GPIO_PIN13)

#define LCD_GPIO_OUTPUT_D11 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                             GPIO_OUTPUT_SET | GPIO_PORTE | GPIO_PIN14)

#define LCD_GPIO_OUTPUT_D12 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                             GPIO_OUTPUT_SET | GPIO_PORTE | GPIO_PIN15)

#define LCD_GPIO_OUTPUT_D13 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                             GPIO_OUTPUT_SET | GPIO_PORTD | GPIO_PIN8)

#define LCD_GPIO_OUTPUT_D14 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                             GPIO_OUTPUT_SET | GPIO_PORTD | GPIO_PIN9)

#define LCD_GPIO_OUTPUT_D15 (GPIO_OUTPUT | GPIO_SPEED_50MHz | \
                             GPIO_OUTPUT_SET | GPIO_PORTD | GPIO_PIN10)

#define LCD_GPIO_INPUT_D0 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTD | GPIO_PIN14)
#define LCD_GPIO_INPUT_D1 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTD | GPIO_PIN15)
#define LCD_GPIO_INPUT_D2 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTD | GPIO_PIN0)
#define LCD_GPIO_INPUT_D3 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTD | GPIO_PIN1)
#define LCD_GPIO_INPUT_D4 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTE | GPIO_PIN7)
#define LCD_GPIO_INPUT_D5 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTE | GPIO_PIN8)
#define LCD_GPIO_INPUT_D6 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTE | GPIO_PIN9)
#define LCD_GPIO_INPUT_D7 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTE | GPIO_PIN10)
#define LCD_GPIO_INPUT_D8 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTE | GPIO_PIN11)
#define LCD_GPIO_INPUT_D9 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTE | GPIO_PIN12)
#define LCD_GPIO_INPUT_D10 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTE | GPIO_PIN13)
#define LCD_GPIO_INPUT_D11 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTE | GPIO_PIN14)
#define LCD_GPIO_INPUT_D12 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTE | GPIO_PIN15)
#define LCD_GPIO_INPUT_D13 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTD | GPIO_PIN8)
#define LCD_GPIO_INPUT_D14 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTD | GPIO_PIN9)
#define LCD_GPIO_INPUT_D15 (GPIO_INPUT | GPIO_FLOAT | GPIO_PORTD | GPIO_PIN10)

struct ili9327_lcd_s *gw_lcd_init(void);

void stm32_gpiowrite_in_regester_pe(uint32_t pinset, bool value);
void stm32_gpiowrite_in_regester_pd(uint32_t pinset, bool value);
bool stm32_gpioread_in_regester_pd(uint32_t pinset);
bool stm32_gpioread_in_regester_pe(uint32_t pinset);
#endif